{$I COND.MG}
unit struct;

interface

{$F+}

uses tools,
{$IFNDEF WIN}
crt,dos;
{$ENDIF}
{$IFDEF WIN}
wincrt,windos;
{$ENDIF}

(* Warning: All structures are subject to change without notice.
any str* type structure, where * is a number, is of type string[*]

type XLatTable_=array[1..128] of char;  translation table for non-ASCII*)

const _SIZEDATE=20;  {FSC001}
      _SIZESUBJ=70;
      _SIZENAME=35;

type strName=string[_SIZENAME];
     strSubj=string[_SIZESUBJ];
     strDate=string[_SIZEDATE];
     strBBS=string[30];
     strNode=string[40];
     strAREA=string[51];
     
const _totalzips=6;
type ArjZip=array[1.._totalzips] of string[45];
const _totalgrades=10;
type _grade=array[1.._totalgrades] of char;
type _groupsrec=array[1..26] of str35;
type _FileNames=array[1..8] of str8;
type _Uspec=array[1..10] of str12;
type _Akas=array[1..20] of StrNode;
type _Dzone=array[1..20] of byte;
type _Dname=array[1..20] of str30;
type _Anode=array[1..20] of char;
type _options=array[1..16] of str3;     {opcoes de set de flags}
const _totallinks=255;   {must be less than 256. Fido and UUCP downlinks}

const UAllUser_Flg:_options=('HLD','DIR','CSH','KIL','ECH','UUP','OUT','UAS','BAD','','','','','','','OFF');
      {HLD, DIR, CSH, KIL - flags de netmail para email vindos da Internet}
      _ECH=16;     {Echo accepted thr Uuencode via the domain listed in the entry}
      _UUP=32;     {UUCP not allowed with spec domain in the entry}
      _OUT=64;     {indica que o usuario esta de ferias e ativa reply automatico}
      _AS=128;     {user may send AS: mail to simulate another UUCP user}
      _BAD=256;    {ON=mail from this user will be checked against bad UUCP destinations in \mg\uucp\mgubad*.lst}
      _OFF=32768;  {entry temporarily off}
{--------------------------------------------------------------}
const _NETHLD=1; {same constants used throughout the various flags}
      _NETDIR=2;
      _NETCSH=4;
      _NETKIL=8;  {used for all netmail status}
      _TICSND=16; {TIC downlink may send files for distribution}
      _TICRCV=32; {TIC downlink may receive files from distribution}
      _TICACT=64; {node active or inactive. Inactive=ignore node momentarily}
{-----------------------------------------------------------}
const Fidonode_flags:_options=('SND','RCV','','','','','','','','','','','','','','');
      _FLNKSND=1;  {Fido node may SEND (broadcast) echomail}
      _FLNKRCV=2;  {Fido node may RECEIVE echomail from redistribution}
type _nodes=record
      zone,net,node,point:word;
      status:word;  {taken from Fidonode_flags}
      end;
type _FidoLinks=array[1.._totallinks] of _nodes; {Fido AREAS downlinks}
const Uucpnode_flags:_options=('SND','RCV','','','','','','','','','','','','','','');
      _ULNKSND=1;  {uucp node may SEND (broadcast) news}
      _ULNKRCV=2;  {uucp node may RECEIVE news from redistribution}
type _uucpnode=record
     UucpNode:str14;
     status:word;  {taken from uucpnode_flags}
     end;
type _Newslinks=array[1.._totallinks] of _uucpnode;  {UUCP AREAS downlinks}

{-----------------------------------------------------------}
const area_flags1:_options=('HLD','DIR','CSH','KIL','SND','RCV','DUP','CRC','AUT','VIR','RES','DIF','SCN','FIX','MAG','EXC');
      {HLD, DIR, CSH, KIL - flags de netmail default para nodes desta area}
      {_TICSND  indica se node pode enviar file para distribuicao}
      {_TICRCV  indica se node ira' receber arquivos em distribuicao}
      _TICDUP=64;     {OFF indica que o MG nao vai verificar se o file ja existe no dir destino e vai hatcha-lo}
      _TICCRC=128;    {*usa o processo de CRC ou bypass de arquivos nessa area}
      _TICAUTIDX=256; {*permite ou nao inclusao automatica de nodes nao listados}
      _TICVIR=512;    {*allow scan de virus nos inbound files pelo tic}
      _TICRES=1024;   {*reset time/date in onbound tic files}
      _TICDIF=2048;   {rescan directory for nodediffs (numbered files in extension) for distribution}
      _TICSCN=4096;   {automatically scan this area for new files in the subdir(send)}
      _TICFIX=8192;   {users may request file search in this area thr echomail filefix}
      _TICMAG=16384;  {indica se a area e' para arquivos MAGIC exclusivamente ou se o TIC pode passar tambem}
      _TICEXC=32768;  {informacoes do MAGIC se sobrepoem sobre o TIC e cancela o TIC}

const area_flags2:_options=('RAF','SOP','PST','ARC','BAN','','','','','','','','','','','');
      _TICRAF=1;  {ON=This is a RA internal FileBase area}
      _TICSOP=2;  {ON=if echo area is ommitted, send tic report to sysop}
      _TICPST=4;  {ON = Pass-through area. Do not hatch file to the local BBS system}
      _TICREARC=8; {ON - Convert inbound files to a new compressor}
      _TICBAN=16;  {ON - Include banner in the file archive}

type tic_cfg=record  {internal to mg.cfg}
     TicNode,
     NodeEcho:StrNode; {node default for the echo node of new TIC Areas}
     Groups_names:_groupsrec; {tic group names}
     FixAlias:_FileNames;
     EchoReport:StrArea;{default echomail area for new TIC Areas}
     Filetab:byte;   {spaces to separate file name/description in files.bbs}
     Virus:str12;    {name of antivirus. PATH will be used for searching}
     CmdPath:str80;  {command line for virus}
     VirusErr:byte;  {errorlevel reported by virus program}
     ZipType,        {type of compressor for DIF releases}
     ZipChar:char;   {character for the extension name of DIF releases}
     AliasFile:str80;{alias file for file requests}
     ReZip,          {programs + switches to compress one file being converted from another type}
     ReUnZip,        {programs + switches to uncompress one file to be converted to another type}
     banners:ArjZip; {programs + switches to add banners to TIC compressed files}
     cfgflg1:word;    {default flags for new TIC Areas}
     cfgflg2:word;    {default flags for new TIC Areas}
     end;

{--------------------------------------------------------------}
const Fld_Flags2:_options=('VIP','NWS','LST','LOC','PVT','PUB','FIL','822','FRW','NID','TO:','DIG','CLS','FRM','INF','POM');
      _FLD2VIP=1;    {Only UUCP VIP users may use the UUCP<->Echo gateway}
      _FLD2NWS=2;    {Newsgroup activated}
      _FLD2LST=4;    {List activated}
      _FLD2LOC=8;    {List is local. Activate listserver + subscription}
      _FLD2PVT=16;   {ON=Private List}
      _FLD2PUB=32;   {ON = Local List Area is Public. Mail from Internet is accepted}
      _FLD2FIL=64;   {ON=Area will be scanned for UUCP files in automatic release}
      _FLD2822=128;  {ON=include full RFC-822 header in echomail messages}
      _FLD2FRW=256;  {If mail from remote list, still forward a copy via netmail to the listuser}
      _FLD2NID=512;  {New ID. If ON, MG generates new msgid for fido mail created from UUCP inbound mail}
      _FLD2UTO=1024; {look for valid uucp To: destination in PKT message and send as email}
      _FLD2DIG=2048; {If list is LOC, ON means that DIGEST files will be generated and eventually sent to users with DIG flg}
      _FLD2CLS=4096; {If ON, no RFC822 header will be imported from UUCP into echomail. This flag overrides 822}
      _FLD2FRM=8192; {If ON, the From: field of echomail from UUCP will include the Fantasy name. OFF, domain of sender}
      _FLD2INF=16384; {ON, in PKT to News, MG will automatically include the To: user name of pkt}
      _FLD2POM=32768; {ON, Postmaster of local list will be notified of new subscriptions}
const Fld_Flags3:_options=('PKT','FAX','FIX','NTY','','','','','','','','','','','','MOD');
      _FLD3PKT=1; {Gateway Pkt to Pkt with Echo fakenode}
      _FLD3FAX=2; {Fax gate activated}
      _FLD3FIX=4; {Tic FileFix-echomail gateway. Search for files in this area}
      _FLD3NTY=8; {if ON, filefix notification will be sent via netmail instead of the echomail the request came from}
      _FLD3MOD=32768; {ON, Postmaster of local list can sub/unsub other users remotely}

type MgFolder_=record    {\MG\AREAS\FOLDERS.MG. \MG\AREAS\FOLDERS.NOW forces the creation of new indexes}
     FolderName:strAREA; {name of message folder}
     board:byte;       {# do board if msg hudson}
     group:word;       {message group of this area}
     ReadSec:word;     {security to access/read the folder}
     WriteSec:word;    {security to post mail in the folder}
     SysopSec:word;    {sysop security to read PVT mail and delete msgs}
     BaseDir:str128;   {file/path of JAM/SQUISH/MSG area}
     MainNode:strNode; {AKA Node used in this area}
     OrigLine:str60;   {Origin Line}
     TearLine:str60;   {TearLine}
     FolderGate:strAREA; {folder in echomail gateway with FolderName}
     FidoLinks:_FidoLinks; {echomail Fido downlinks}
     NewsGroup:str80; {name of newsgroup in gateway, if any}
     NewsLinks:_NewsLinks; {news downlinks}
     ListGroup:str80; {name of uucp List in gateway}
     ListTitle:str40; {description of List, if local}
     PostMaster:str80;{domain of postmaster/List owner}
     Welcome,    {welcome to new subscriptions for the List Area}
     Query,      {Query text file for the list area}
     UserBase,   {Database with subscribed users}
     Signature,  {Signature, footer of all outbound UUCP mail in distribution}
     GetFiles:str8;   {List of subdirectories reachable with the GET command}
     Distrib:string[44]; {newsgroup distribution}
     FilesDir:Pathstr;{file directory for Listserver file base}
     PhoneFax:strSubj;{fax destination for the echomail}
     FaxGrade:char;   {Fax grade for mail generated to the fax server}
     areatype:byte;   {Hudson(1), Jam(2), Squish(3), SyncNet(4)}
     toss:boolean;    {ON=Import directly to base and export to downlinks OFF=Create fake PKT for external tosser}
     echo:boolean;    {ON=Echomail area OFF=Netmail area (for import/export of all local AKAS)}
     folderflg2:word; {UUCP gateway information}
     folderflg3:word; {other gateway information}
     internal:byte;   {private to the database management. bit0=1 >entry deleted!}
     end;
{--------------------------------------------------------------}
type externo=^externo_;
     externo_=record     {\MG\MG.CFG}
     VerNumber:str5;    {MailGate version number}
     ID:char;           {identify CFG. MG will not run same ID in multitask}
     NodeDir,            {\mg\nodelist}
     AreasDir,           {\mg\areas}
     UucpDir,            {\mg\uucp}
     FidoDir,            {\mg\fido}
     TxtDir,             {\mg\txt}
     UUEDir,             {\mg\files}
     SpoolDir,           {\mg\spool}
     FaxDir,             {\mg\fax}
     TICDir,             {\mg\tic}
     MailDir,            {\fd\mail}
     FileDir,            {\fd\files}
     PacketDir,          {\fd\packet}
     MsgbaseDir,         {\ra\msgbase}
     FileBaseDir:Pathstr;{\ra\files}
     XEditor:str12;     {external ASCII editor. Name only}
     AUTOREPLY,         {AUTORPLY.TXT}
     REPLYLIST1,        {LIST1.TXT}
     REPLYLIST2,        {LIST2.TXT}
     REPLYUUFAX,        {UUCPFAX.TXT}
     NOTINNODE,         {NOTNODE.TXT}
     ERRORSYNTAXUUCP,   {ERRUUCP.TXT}
     ERRORNAMEF,        {ERRNAME.TXT}
     ERRORNODEF,        {ERRNODE.TXT}
     RECEIPTU,          {REPLYU.TXT}
     RECEIPTUBAD,       {UUCPBAD.TXT}
     SENDWARN,          {NOTFOUND.TXT}
     RECEIPTF,          {REPLYF.TXT}
     FOOTFIDO,          {FTFIDO.TXT}
     FOOTUUCP,          {FTUUCP.TXT}
     FAXERR,            {FAXERR.TXT}
     NODEERR,           {FIDNODE.TXT}
     FILEERR,           {FIDFILE.TXT}
     RAIDHELP,          {RAIDHELP.TXT}
     TICUUCP:str12;     {TICUUCP.TXT}
     UucpGate1,         {UUCP Gateway-Primary Net}
     UucpGate2,         {UUCP Gateway-Secondary Net}
     PrimBBS,           {Main Primary Net Node}
     PrimGate,          {Main Primary Gate Node}
     SecdBBS,           {Main Secondary Net Node}
     SecdGate:strNode;  {Main Secondary Gate Node}
     FileFix,           {FileFix netmail/echomail/UUCP server}
     AreaFix,           {Echomail areafixing}
     Fax,               {Fax destination user for mail-to-fax process}
     MGDOS,             {Remote DOS maintenance user}
     Mgserver:str8;     {name of netmail server with various functions}
     FidoUsers:array[1..5] of str8; {special netmail users. Use them whenever you need to implement any special server}
     ArcMail,           {Echomail User Name}
     Sysop:strName;     {Fidonet sysop}
     BBSName,           {BBS name}
     BBSPhone,          {BBS Phone}
     BBSFlgs:str25;     {BBS flags}
     BBSInfo1,          {information}
     BBSInfo2:str60;    {information}
     TZ:str25;          {Time ZONE}
     TicReplyFrom:byte; {Echo and Net FileFix replies: 0=From "MailGate", 1=From: "Sysop", 2=From: "BBS Name"}
     UUCPGrades:_grade; {1=email; 2=local lists; 3=news; 4=UUE files}
     NodeName:str14;    {UUCP Node name. ex: EAR}
     Domains:array[1..10] of str60;  {UUCP local domains of the system. First is mandatory. Ex: EAR.ANPE.BR}
     Organiz:str60;     {UUCP Organization}
     ListServ,          {MG internal Listserver}
     UAreaFix,          {UUCP AreaFixing}
     DefUucpRoute:str14;{Default UUCP system to route mail. ex: ITEP}
     UucpUser:str12;    {UUCP gateway name ex: UUCP}
     UucpCost:real;     {cost in $$ for every Kbyte of UUCP mail for VIP}
     Currency:str25;    {Name of your currency for the UUCP Cost Manager}
     UGateChar:char;    {UUCP gateway character % if using the fake domaining}
     Separat:char;      {_/. to separate user name in uucp user}
     AliasID:char;      {identifies the nodelist/network for system's ALIAS nodelist}
     UucpID:char;       {identifies the UUCP VIP nodelist/network}
     ULocalFlags:word;  {flags for VIP local users if UucpLocalVip is ON}
     UNonVipFlag:word;  {flags for non-VIP users if Uucp Vip is OFF}
     UFIDType:byte;     {0=pure FTS-0009  1=German Gatebau proposal}
     ListMax:byte;      {max number of commands to the listserver}
     FixMax,            {max number of files processed in one FileFix request}
     CCMax,             {max number of UUCP carbon copies}
     UUEmax,            {max number of lines in uuencoded files}
     NetMax,            {max number of bytes in MSG messages 0=ignore}
     PKTmax,            {max number of bytes in PKT messages 0=ignore}
     PktSize,           {max size of PKT in kbytes. 0=ignore}
     NetWriteSec,       {level user needs to write a netmail}
     NetReadSec,        {level user needs to read a netmail}
     NetSysopSec:word;  {level user needs to perform sysop functions in the netmail folder}
     PrimID,            {identifies the Primary Fidonet nodelist}
     SecdID:char;       {identifies the Secondary Fidonet nodelist}
     Ndelst1_1,         {path/name of Primary Fidonet nodelist 1}
     Ndelst1_2,         {path/name of Primary Fidonet nodelist 2}
     Ndelst2_1,         {path/name of Secondary Fidonet nodelist 1}
     Ndelst2_2,         {path/name of Secondary Fidonet nodelist 2}
     semaphore,         {forces rescan in netmail folder \fd\fdrescan.now}
     FaxPrg,            {path/name do programa de fax}
     ExtFaxLog,         {external program to process fax-logging}
     CmdFax:str60;      {command to fax program}
     phonegrid:str25;   {phone grid for local fax}
     LocalGrade:char;   {Fax Grade for local Fax}
     faxtries:byte;     {max number of tries to send a fax}
     FaxID:char;        {identifies the Fax nodelist}
     compress,          {set of compression programs}
     decompress:ArjZip; {set of compression programs}
     SwapPath:PathStr;  {path to swap memory to}
     COMSPEC,           {External shell to DOS will be done by invoking COMMAND.COM}
     SwapEMS,           {use EMS during swap}
     SwapXMS:boolean;   {use XMS during swap}
     LogLevel:byte;     {level of logging MailGate}
     MgLog:str60;       {full path/name of MailGate log file}
     WriteVideo,        {display information on the screen. OFF=faster processing}
     ProcExit,          {execute Batch files after process}
     Proc_Tic,          {process inbound *.TIC and RAID requests}
     Proc_TicNew,       {look for new files to be hatched}
     Proc_TicDif,       {look for DIF releases to be hatched}
     Exec_Fax,          {process netmail in gateway. Fido-Fax}
     Proc_Fax,          {send waiting fax mail. Set only during run-time}
     FaxVip,            {sends Fax mail only for VIP users}
     FaxLocal,          {local users may send Fax mail with no password}
     FaxReceipt,        {sends return receipt for Fax mail}
     FaxLog,            {process external Fax logging}
     FaxError,          {forces MailGate to exit with fax errorlevel}
     FaxFiles,          {ON=file attaches are sent to the fax manager for delivery}
     do_msgbase,        {process all functions for the message base (*.msg)}
     Exec_Fido,         {process netmail in gateway. Fido-Fido}
     Exec_MGServ,       {process netmails to the mgserver}
     Exec_MGDOS,        {process netmails to the MGDOS server}
     Exec_Alias,        {process the netmail alias server}
     Proc_ServMSG,      {execute netmail server. Set only during run-time}
     Proc_ServPKT,      {execute echomail server. Set only during run-time}
     ErrorNameReceipt,  {sends return receipt for Fido bad username}
     ErrorNodeReceipt,  {sends return receipt for Fido node not found}
     FidoReceipt,       {sends return receipt for fido-fido mail}
     Dump_Ok,           {dumps processed netmail in ASCII file}
     KillSent,          {forces processed netmail to be deleted}
     DelSent,           {forces processed file attaches to be deleted}
     DelBad,            {deletes corrupted netmails}
     AutoNode,          {automatically compile nodelists if changed}
     FullQuote,         {use user initials to quote messages in the folder}
     FD2BNK,            {converts local netmail file attaches to Bink style}
     ignore_ndlst,      {ignores search of Fido nodes in nodelists}
     do_tossUucp,       {toss inbound UUCP mail}
     Exec_Uucp,         {process netmail in gateway. Fido-Internet}
     FilesToUUE,        {send file attaches to the Internet}
     UUENoEchoVIP,      {process inbound uuencoded files to VIP users without matching ECHO database}
     Proc_UUServ,       {process listserver requests}
     DumpUUCP,          {dumps inbound uucp mail in ASCII}
     EmailUucpVip,      {sends netmail to the Internet only for VIP users}
     UUVipLocal,        {Local users (one of the Node AKAS) are UUCP VIP}
     LocalUucpHosts,    {Process any UUCP Node from the UUCP node manager that is LOCAL to your computer system}
     AliasUuFidoList,   {Allows MG to search for Net=>UUCP routing from the Fido nodelists}
     PurgeRe,           {purge Re: from the UUCP Subject line}
     UucpReceipt,       {sends return receipt for fido-uucp mail}
     ErrorUucpReceipt,  {sends return receipt for UUCP syntax error}
     BadUucpReceipt,    {sends return receipt for UUCP bad destination}
     CCVipOnly,         {only VIP users may send mail to UUCP in carbon copy}
     Bit7,              {reset the 7th bit of mail to the Internet}
     UUCPReply,         {notifies UUCP users of mail not delivered}
     NoPostMast,        {remote postmaster will not be notified of problems}
     NewID,             {generates new MSGID for UUCP inbound mail}
     NetInfoRFC822,     {ON, includes ^AVIA in rfc822 for netmail in gateway to UUCP}
     Rcvd822ToNet,      {ON, includes Received: by in Netmail for UUCP in gateway to netmail}
     LogCosts,          {Includes cost of netmail to email of all mail flowing thr the system}
     CostAreas,         {includes UUCP costs of List/News areas}
     BadNewsNotify,     {Notify sysop via netmail of inbound newsgroup not found in the areas database}
     BadNewsGroup,      {toss bad newsgroup in PKT even if the area is not found}
     EmailList,         {Email from remote Lists may be converted to PKT. OFF, areas manager wont be scanned for remote lists}
     ProcNews,          {ON=process inbound batched news. OFF, ignore them}
     FastNews,          {Fastest news=>PKT process. No dup check, News limited to max RAM (or truncated), no UUCP downlinks}
     ScanVipPKT,        {OFF, MG will NOT scan VIP base for users and their email in PKT=>News gateway. Default route for all}
     BangMail,          {ON=Email in Bang path format (domain!user). OFF=Email in user@domain format}
     NotOrigin,         {PKT to UUCP will have the Origin: line removed from mail}
     Ucosts,            {ON=mgserver-netmail command UCOSTS will include the cost in $$ for the requestor}
     SetNews,           {New Areas in the Folder => take the echo name and use as the newsgroup name}
     SetList,           {New Areas in the Folder => take the folder name and use as local list}
     NetFromUUCP,       {sender's email in From: of netmail instead of "UUCP"}
     ToUucp,            {look for valid UUCP destination in netmail TO:}
     ReturnUCopy,       {bad netmail to the UUCP gateway will return a copy of the original message to the addresser}
     TrueGate:boolean;  {True UUCP Gate/Fidonet domain - user@xxx.domain}
     FidoMailer,        {Front-Door (0), Binkley/Portal of Power (1)}
     RFC822:byte;       {0=full RFC822 header in netmail from UUCP, 1=partial 2=none}
     UucpSpec:_Uspec;   {uucp special servers}
     DigestDays:byte;   {days of week when MG scans for DIGEST list mail to be distributed. LSB=all days MSB=Saturday 0=none}
     NodeAKAS:_Akas;    {Node numbers of the system - mailer}
     DomainsZone:_Dzone;{Zones to match domain names}
     DomainsName:_Dname;{domains of the system}
     MatchZone:_Akas;   {System nodes matching Zones}
     MatchAKA:_Dzone;   {Zones to match AKA nodes}
     AllNodes:_Anode;   {all Nodelist IDs for general search}
     XLatTable:XLatTable_;   {used to change characters >127 to ASCII}
     mgfolder:mgfolder_;     {default config for new folder areas}
     ticcfg:tic_cfg;         {config of the TIC manager}
     end;

{--------------------------------------------------------------}
type Folderidx_=record  {\MG\AREAS\FOLDERS.NDX}
     FolderName:StrAREA;
     group:word;     {group of this folder}
     security:word;  {level to access folder}
     location:LongInt;
     end;

type FolderCrcidx_=record  {\MG\AREAS\FOLDERS.CDX}
     FolderNameCrc:LongInt;
     location:LongInt;
     end;

{--------------------------------------------------------------}
type Newsidx_=record {\MG\AREAS\NEWS.IDX}
     AreaNewsCrc:LongInt;  {CRC of NewsGroup}
     location:LongInt;    {position of area in mgfolder_}
     end;

{--------------------------------------------------------------}
type Listidx_=record {\MG\AREAS\LISTS.IDX}
     ListAreaCrc:LongInt;  {CRC of List}
     PostmastCrc:LongInt;  {CRC of Postmaster}
     location:LongInt;    {position of area in mgfolder_}
     end;

{-----------------------------------------------------------}
const FidoManager_flg1:_options=('HLD','DIR','CSH','KIL','','','','','','','','','','','','');
const FidoManager_flg2:_options=('','','','','','','','','','','','','','','','');
type _FidoNodeManager=record  {\MG\FIDO\FNODES.DAT}
     Zone,Net,Node,Point:word;
     Sysop:strName;
     PktPwd:str8;
     AFixPwd:str16;
     ZipType:char;
     Manflag1,
     Manflag2:word;  {operational flags}
     end;

{-----------------------------------------------------------}
const UNode_flg1:_options=('HLD','DIR','CSH','KIL','AFX','BAT','CUN','STR','ZIP','GTW','OUT','BNK','BAG','CNV','LOK','OFF');
      {HLD, DIR, CSH, KIL - flags de netmail default para nodes desta area}
      _UNODE1FIX=16;   {postmaster is allowed to use the areafix}
      _UNODE1BAT=32;   {news will be sent batched or unbatched}
      _UNODE1CUN=64;   {Adds "#! cunbatch\n" to outbound news}
      _UNODE1STR=128;  {removes "#! cunbatch\n" from inbound news}
      _UNODE1ZIP=256;  {outbound mail will be compressed and file attached to RouteFido}
      _UNODE1GTW=512;  {active only with ZIP ON. If ON, MG will execute the UUCP conversion locally before compressing}
      _UNODE1OUT=1024; {move UUCP outbound mail to the outbound Fido file and attach. OFF, move inbound UUCP mail}
      _UNODE1BNK=2048; {Fidonet attach via Binkley format}
      _UNODE1BAG=4096; {Toss BAG news mail from \mg\spool\ear\bag\}
      _UNODE1CNV=8192; {UUCP node is local to your LAN system. Out/inbound mail will be switched}
      _UNODE1LOK=16384;{ON, security is active, which means that MG will toss only mail from provider in the spool dir}
      _UNODE1OFF=32768;{UUCP node is temporarily OFF}

type _UUcpNodeManager=record  {\MG\UUCP\UNODES_*.DAT}
     UucpNode:str14;    {Uucp node name. Ex: LACOSA}
     PostMaster:str80;  {Postmaster of the system}
     Sysop:strName;     {FidoNet Sysop}
     LocalFido,         {From: Local node number of file attach}
     RouteFido:strNode; {node to which compressed uucp mail will be sent, if any}
     FidoAttachIn,      {Name of the File with inbound UUCP mail, coming from remote Fido node}
     FidoAttachOut:str8; {Name of the File with outbound UUCP mail, attached to a netmail}
     UFixPwd,           {password to access the uucpfix ON/OFF news areas}
     FidoZipPwd:str16;  {password used to pack uucp mail via Fido link}
     ZipNews:char;      {compressor of outbound newsgroups}
     ZipType:char;      {compressor used if _MAPZIP is ON}
     UFlags1:word;      {operational flags}
     UucpMailer:byte;   {Waffle's UUCICO (0) PCB (1)}
     reserved:byte;
     internal:byte;     {internal flag}
     end;

type UNodeidx=record  {UNODES_*.DDX}
     UucpNode:str14;
     location:Longint;
     end;

{-----------------------------------------------------------}
type MapDat=record   {MGUMAP_*.DAT   - Fido Node x UUCP subdomain}
     Zone,Net,Node,Point:Word;  {BBS system to be mapped}
     UucpDomain:str14;           {"uucp" subdomain}
     Description:str80;         {general description}
     FlgNode:word;              {flags}
     end;

type MapDomainidx=record  {MGUMAP_*.DDX}
     UucpDomain:str14;
     location:Longint;
     end;

type MapNodeIdx=record    {MGUMAP_*.BDX}
     Zone,Net,Node,Point:word;
     location:Longint;
     end;


{-----------------------------------------------------------}
const Lists_flags:_options=('NML','CEL','ACK','REP','VIP','AFD','FUI','DIG','','','','','','','','');
     _NML=1;       {NOMAIL is ON, usuario nao recebera' mail em distribuicao}
     _CONCEAL=2;   {ON=Private - O domain do usuario nao sera' publicado sob comando REVIEW}
     _ACK=4;       {if ON, usuario recebera confirmacao de distribuicao de seu mail}
     _REP=8;       {if ON, usuario recebera' um echo de seu proprio mail em distribuicao}
     _LISTVIP=16;  {if ON, the user may request files with the GET/SEND listserver command}
     _AFD=32;      {ON, the system will receive new files whenever they're updated in the system}
     _FUI=64;      {ON, receive notification of file updates}
     _DIG=128;     {ON, user will receive mail in DIGEST form, if the Local List is set to do so}
type UserInList_=record   {\MG\AREAS\LISTUSER.DAT  - subscribed users}
     UserDomain,
     UserFantasy:str80;
     password:str8;
     ListFlg:word;
     end;

type ListDomainIdx=record  {\MG\AREAS\LISTUSER.IDX}
     ListDomainCrc:LongInt;
     location:Longint;
     end;

{--------------------------------------------------------------}
const Group_flags:_options=('','','','','','','','','','','','','','','','');
type mggroups_=record   {\MG\AREAS\GROUPS.MG}
     GroupName:StrArea;  {name of message group}
     Group:word;         {group number}
     Security:word;      {security to access group}
     groupflg:word;
     end;

{--------------------------------------------------------------}
const users_flags:_options=('HLD','DIR','CSH','KIL','SUP','','','',
                             '','','','','','','','');
      {HLD, DIR, CSH, KIL Default netmail flags in the folder}
      _USRSUP=16;  {ON=User is supervisor}
type mgusers_=record    {\MG\FIDO\MGUSERS.DAT - users accessing the system}
     UserName:StrName;  {name of user}
     pwd:str16;        {password to access the system}
     security:word;    {access security level}
     status:word;      {user status}
     end;

{--------------------------------------------------------------}
const alias_flags:_options=('HLD','DIR','CSH','KIL','NET','FAX','UUP','BCC','','','','','','','','');
      {HLD, DIR, CSH, KIL - netmail flags for netmail to alias user}
      _ALANET=16;  {ON=Net Destination}
      _ALAFAX=32;  {ON=Fax Destination}
      _ALAUUP=64;  {ON=UUCP Destination}
      _ALABCC=128;  {OFF - UUCP Carbon Copy. ON - UUCP Blind Carbon Copy}
type mgalias_=record   {MGALIAS.DAT - User To: in the msg folder}
     AliasName:strName; {nome fantasia de UUCP ou user name de Fax, etc}
     UserInfo2:Str80;
     status:word;
     end;

{-----------------------------------------------------------}
type groups_boolean=array[1..26] of Boolean;
const ticnodeman_flags1:_options=('HLD','DIR','CSH','KIL','FRW','NEW','AUT','MAG','FMG','NFY','MSG','BNK','','','','');
      {HLD, DIR, CSH, KIL - flags de netmail notify do RAID}
      _TICFRW=16;     {pode solicitar acao do RAID em nome de terceiros}
      _TICNEW=32;     {pode criar areas inexistentes no sistema}
      _TICAUTMAN=64;  {node may add itself in tic Areas if not yet in the area}
      _TICAUTMAG=128; {remote node may include new MAGIC file in the system}
      _TICFRWMAG=256; {remote node may update existing MAGIC file}
      _TICNFY=512;    {Turn on/off the notify function for options}
      _TICMSG=1024;   { turn on/off the message function??}
      _TICBNK=2048;   {OFF (Front-Door) MG generates a netmail file attach. ON, FLO file (compatible with Bink/Portal}
const ticnodeman_flags2:_options=('','','','','','','','','','','','','','','','');
type tic_NodeManager=record   {TICNODE.DAT}
     Node:strNode;            {node number}
     Sysop:StrName;           {sysop name}
     TICPassword,             {Password for TIC files}
     RAIDPassword:str8;       {password for RAID requests}
     groups:groups_boolean;   {available TIC groups}
     nodemanflg1,             {operational flags}
     nodemanflg2:word;        {operational flags}
     end;

{-----------------------------------------------------------}
(* areaflg1 and areaflg2 use consts area_flags1 and area_flags2 *)
type Tic_Areas=record   {\MG\TIC\TICAREAS.DAT}
     TicArea:str16;     {name of TIC or MAGIC Area}
     AreaDesc:str80;    {Area description}
     AreaDir:PathStr;   {TIC Area subdirectory}
     TicNode,           {Main node of this area}
     NodeEcho:StrNode;  {Node that will receive echo from TicNode}
     FilesBBS:str80;    {path/name of files.bbs}
     ReArc:char;        {Convert inbound files to this compressor type}
     RaFileidx:word;    {index of RA file area (if RA filebase in use}
     DefaultDesc:str80; {default description for files}
     EchoReport:StrArea;{Echomail area for TIC reports}
     Group:char;        {Tic group this area belongs to}
     areaflg1,          {operational flags}
     areaflg2:word;     {operational flags}
     end;

{-----------------------------------------------------------}
const ticnodeflg1:_options=('HLD','DIR','CSH','KIL','SND','RCV','ACT','','','','','','','','','');
      {HLD, DIR, CSH, KIL - flags de netmail com o TIC attach de distribuicao}
      {_TICSND  indica se node pode enviar file para distribuicao}
      {_TICRCV  indica se node ira' receber arquivos em distribuicao}
      {_TICACT=64; {node active or inactive. Inactive=ignore node momentarily}
const ticnodeflg2:_options=('','','','','','','','','','','','','','','','');
type tic_NodeEstruct=record  {*.NTC. Downlink TIC nodes}
     NodeTo:StrNode;    {Node number}
     nodestflg1,        {operational flags}
     nodestflg2:word;   {operational flags}
     end;

const ticuserflg1:_options=('HLD','DIR','CSH','KIL','','RCV','ACT','BNK','ATT','','','','','','','');
      {HLD, DIR, CSH, KIL - flags de netmail com o TIC attach de distribuicao}
      {_TICRCV  indica se node ira' receber arquivos em distribuicao}
      {_TICACT  node active or inactive. Inactive=ignore node momentarily}
      _TICUSRBNK=128;  {Bink/portal file attach style}
      _TICATT=256; {ON=File attach TIC file to node. OFF, send only the TIC report}
const ticuserflg2:_options=('','','','','','','','','','','','','','','','');
type tic_UserEstruct=record  {*.UTC. Downlink TIC individual users}
     UserName:strName;  {destination user of tic file attach}
     NodeTo:StrNode;    {Node number}
     userstflg1,        {operational flags}
     userstflg2:word;   {operational flags}
     end;


{-----------------------------------------------------------}
type UucpDat=record     {MGUUCP_*.DAT  -  UUCP VIP user database}
     Zone,Net,Node,Point:Word;  {node number of UUCP VIP user}
     UucpUserID:str80;          {UUCP address of VIP User}
     UserName:strName;          {Fidonet user name}
     ID:char;                   {identification character}
     Info1,                     {general information 1}
     Info2:str80;               {general information 2}
     CostFactor:real;           {indicates the factor over the UUCP Cost}
     VipFlg1,
     VipFlag2:word;             {operational flags}
     internal:byte;             {internal to the databse management. bit0=1 =>deleted!}
     end;

type UucpNameidx=record   {MGUUCP_*.NDX}
     UserNameCrc:Longint;
     location:Longint;
     end;

type UucpDomainidx=record {MGUUCP_*.DDX}
     UucpUserCrc:LongInt;
     location:Longint;
     end;

type UucpNodeIdx=record   {MGUUCP_*.BDX}
     Zone,Net,Node,Point:word;
     location:Longint;
     end;

type UUIDidx=record       {MGUUCP_*.IDX}
     ID:char;
     location:Longint;
     end;

{-----------------------------------------------------------}
const EchoDat_flags:_options=('','','','','','','','','','','','','','','','');
type EchoDat=record   {MGECHO_*.DAT   - echo UUCP x Fidonet file attaches}
     Zone,Net,Node,Point:Word;
     EchoUserID:str80;
     UserName:strName;
     FlgNode:word;
     end;

type EchoNameidx=record   {MGECHO_*.NDX}
     UserNameCrc:Longint;
     location:Longint;
     end;

type EchoDomainidx=record  {MGECHO_*.DDX}
     EchoUserCrc:LongInt;
     location:Longint;
     end;

type EchoNodeIdx=record    {MGECHO_*.BDX}
     Zone,Net,Node,Point:word;
     location:Longint;
     end;

{-----------------------------------------------------------}
const FileFix_flags:_options=('HLD','DIR','CSH','KIL','RQT','','','','','','','','','','','');
      {HLD,DIR,CSH,KIL - flags used in the netmail to: FileFix sent to FixBBS}
      _FIXRQT=16;      {instead of looking for files in FilesBBS, send a netmail to Mgserver, in FixBBS, with the request}
type FileFixDat=record   {FILEFIX.DAT   - FileFix FILES.BBS Database}
     Zone,Net,Node,Point:word;  {FixBBS for which FilesBBS is used}
     FilesBBS:str12;            {name of file in \mg\tic\filefix\}
     Comments:str80;            {description of BBS}
     FlgNode:word;              {flags}
     end;

{-----------------------------------------------------------}
const FaxDat_flags:_options=('HLD','DIR','CSH','KIL','','','','','','','','','','','','');
      {HLD, DIR, CSH, KIL - flags de netmail para email vindos da Internet}
type FaxDat=record       {MGFAX_*.DAT    - VIP FAX user x Fidonet user}
     Zone,Net,Node,Point:Word;
     UserPwd:str8;
     UserName:str80;
     netuser:boolean;       {true=username netmail false=username uucp}
     FaxGrade:char;
     FlgNode:word;
     end;

type FaxNameidx=record    {MGFAX_*.NDX}
     UserNameCrc:Longint;
     location:Longint;
     end;

const alias_flg:_options=('HLD','DIR','CSH','KIL','OFF','NET','UUP','FAX','1ST','LST','','','','','','');
      {HLD,DIR,CSH,KIL - flags used in netmail converted to netmail}
      _ALIOFF=16;  {disable entry}
      _ALINET=32;  {destination is a netmail}
      _ALIUUP=64;  {destination is UUCP}
      _ALIFAX=128; {destination is a Fax}
      _ALI1ST=256; {include Netmail From: user name as the user name of From: UUCP email in the beggining of ForwardToUser}
      _ALILST=512; {include Netmail From: user name as the user name of From: UUCP email in the end of ForwardToUser}
type AliasDat=record   {ALIAS_*.DAT  - Alias manager/user database}
     ToUserName:StrName;
     zo1,ne1,no1,po1:word;
     ForwardToUser:str80;
     zo2,ne2,no2,po2:word;
     aliasflg:word;
     end;

type AliasNameidx=record   {ALIAS_*.NDX}
     ToUserNameCrc:LongInt;
     location:Longint;
     end;

{--------------------------------------------------------------}
type custos=record           {MGCOST_*.DAT}
     UserName:strName;       {name of Fido user who used the gateway}
     NodeNumber:StrNode;     {node number of user who used the gateway}
     UucpName:str80;         {Destination UUCP user of this message}
     BytesUsed:LongInt;      {total number of bytes processed}
     day,month,year,         {date/hour the msg was processed}
     hour,minute,second:word;
     Echomail:boolean;       {mail from echo/list/news or private email}
     FromInternet:boolean;   {true=mail from the Internet to the user}
     Processed:byte;         {entry already processed}
     end;

type faxbase=record          {*.FBF  -  Fax phone database/mailing list}
     FaxName:str25;          {system name}
     Info1,
     Info2,
     Info3:str80;
     Voice,                  {voice phone number}
     phonefax:str25;         {fax phone number}
     end;

type ValidNodeList=record         {VALIDNDE.DAT - validate nodelist}
     node1,
     node2:str128;      {full path/name of nodelists}
     Date1,Time1:str8;  {date/time of nodelist 1}
     Size1:LongInt;     {file size of nodelist1}
     Date2,Time2:str8;  {date/time of nodelist 1}
     Size2:LongInt;     {file size of nodelist2}
     SizeA,
     SizeB:LongInt;     {file sizes of *DX files}
     end;

type nodeidx=record          {NODELIST.MDX}
     Zone,Net,Node:Word;
     WhichNode:byte;         {1=main nodelist; 2=second nodelist}
     StartFrom:LongInt;
     end;

type sysopidx=record         {USERLIST.MDX}
     UserName:StrName;
     WhichNode:byte;         {1=main nodelist; 2=second nodelist}
     StartFrom:LongInt;
     end;

type _origs=record    {\MG\FIDO\ORIGIN.DAT}
     OriginLine:str60;    {origin line}
     end;

type mgdoc=record  {\mg\mg.doc}
     linha:str80;
     end;

type mgdocidx=record  {\mg\mgdoc.idx}
     serial:str3;     {serial number, indicator of help command}
     location:Longint;  {record of mgdoc where the text starts}
     size:word;     {number of records of text message}
     end;


type mgdesk_=record  {\mg\MGDESK.CFG}
     mouse_ok:boolean;
     Keybuffer:string;
     end;

IMPLEMENTATION
BEGIN
END.